public class Ball{
 
 PVector location; 
 float radius;
 int row, col, plaidSize;
 float hei;
 color c;
 Boolean isLeader; 
 float thresh;
 
 
 Ball(int sRow, int sCol, int _plaidSize,  float ballSize, color _c, Boolean _isLeader){
   location = new PVector(0,0,0);
   radius = ballSize;
   row = sRow;
   col = sCol;
   plaidSize = _plaidSize;
   c = color(random(255),random(255),random(255));  ;//_c;
   isLeader = _isLeader;
   thresh = random(5,20);
 }
 
 
 
 void update(){
  
  int tmpX = col;
  int tmpY = row;
  
  if(tmpX >= rows-1){
    tmpX = 1;
  }else if(tmpX <= 0){
    tmpX = rows-2;
  }else{
    if( abs(heightMap[tmpX+1][tmpY]) - abs(heightMap[tmpX-1][tmpY]) > thresh ||  abs(heightMap[tmpX-1][tmpY])- abs(heightMap[tmpX+1][tmpY]) > thresh  ){
        if(heightMap[tmpX+1][tmpY] > heightMap[tmpX-1][tmpY]){
          tmpX --;
        }else{
          tmpX ++;
        }
      }// no change
  }
  
  if(tmpY >= cols-1){
    tmpY = 1;
  }else if(tmpY <= 0){
    tmpY = cols-2;
  }else{
    if(abs(heightMap[tmpX][tmpY+1]) - abs(heightMap[tmpX][tmpY-1]) > thresh || abs(heightMap[tmpX][tmpY-1]) - abs(heightMap[tmpX][tmpY+1]) > thresh){
      if(heightMap[tmpX][tmpY+1] > heightMap[tmpX][tmpY-1]){
        tmpY --;
      }else{
        tmpY ++; 
      }
    }// no change 
  }
  
  col = tmpX;
  row = tmpY;
  hei = heightMap[col][row]; 
 }
 
 
 void display(){
  setSoundProperties(0.5, hei*2+20);
  pushMatrix();
  translate((col) * plaidSize  + plaidSize/2 ,(row) * plaidSize +plaidSize/2, hei*2+ radius);
    fill(c);
    sphere(radius);
    stroke(c, 64);
    //line(0,0,-2000,0,0,2000);
    noStroke();
  popMatrix();
 }
 
 
 void follow(){
   int leaderRow = leader.row;
   int leaderCol = leader.col;
   float threshFollow = 5;
   
   if(row < leaderRow){
     // go right
     if( heightMap[col][row+1] - heightMap[col][row] < threshFollow   ){
       row++;  
     }
     
   }else{
     // go left
     if( heightMap[col][row-1] - heightMap[col][row] < threshFollow   ){
       row--;  
     }
   }
   
   if(col < leaderCol){
     if( heightMap[col+1][row] - heightMap[col][row] < threshFollow   ){
       col++;  
     }
   }else{
     if( heightMap[col-1][row] - heightMap[col][row] < threshFollow   ){
       col--;  
     }
   }
   
   
 }
  
  
}


